#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
int speed=10; //globln promnn urujc rychlost oten


interrupt 8 void tpm1ovf (void) {
//peruen pi skonen periody PWM
asm {
bclr 7,TPM1SC //nulovn pznaku peruen
}
//sputn motorku
if (speed>=122 && speed<=132) {
//pokud trimr uprosted (s jistou toleranc), motor stoj
PTAD_PTAD5=1;
PTAD_PTAD4=1;
}
else if (speed<122) {
//to vzad
PTAD_PTAD4=0;
PTAD_PTAD5=1;
}
else if (speed>132) {//to vped
PTAD_PTAD4=1;
PTAD_PTAD5=0;
}
}


interrupt 5 void tpm1ch0 (void) {
//peruen pi skonen pulzu PWM
asm {
bclr 7,TPM1C0SC //nulovn pznaku peruen
}
//zastaven motorku
PTAD_PTAD4=1;
PTAD_PTAD5=1;
}


interrupt 23 void atdcoco (void) {
//peruen pi skonen AD pevodu
speed=ATD1RH; //ten vsledku
if (speed<127) {
TPM1C0V=16*2*(-speed+127); // nastaven dlky pulzu PWM, toen vzad
}
else {
TPM1C0V=16*2*(speed-127); //nastaven dlky pulzu PWM, toen vped
}
ATD1SC=0b01000000; //povolen dalho pevodu
}



void main(void) {
/*** vypnut watchdogu ***/
SOPT_COPE=0;
/*** ASOVA ***/
TPM1SC=0b01001110; //interrupt enable, clock: busclk, prescaler: 64
TPM1MOD=0x1000; //modulo regist uruje periodu cyklu PWM (0x1000=#4096)
//kanl 0:
TPM1C0SC=0b01101000; //interrupt enable, mode: edge-aligned PWM
TPM1C0V=0x0010;
/*** AD PEVODNK ***/
ATD1PE_ATDPE0=1; //ATD Pin Enable: povolen pinu 0 jako vstupu do AD
ATD1C_ATDPU=1; //ATD Power Up: zapne AD pevodnk
ATD1C_RES8=1; //ATD Result: vsledek pevodu bude 8bitov
ATD1SC=0b01000000; //ADTSC: povolen peruen,pevodu a vbr kanlu 0
/*** PORT PTA ***/
//ovld desku Evb Motor
PTAD=0b00110000; //povolen motorku, nastaven IN1 a IN2 na 1
PTADD=0b00111100; //nastaven pin 2 a 5 pro zpis
EnableInterrupts; //povolen peruen
for(;;) {
//nekonen smyka, zachytvaj se peruen od asovae a AD pevodnku
}
}


